/* gee-1.0.vapi generated by valac, do not modify. */

[CCode (cprefix = "Gee", lower_case_cprefix = "gee_")]
namespace Gee {
	[CCode (cheader_filename = "gee.h")]
	public abstract class AbstractCollection<G> : GLib.Object, Gee.Iterable<G>, Gee.Collection<G> {
		public abstract bool add (G item);
		public virtual bool add_all (Gee.Collection<G> collection);
		public abstract void clear ();
		public abstract bool contains (G item);
		public virtual bool contains_all (Gee.Collection<G> collection);
		public abstract Gee.Iterator<G> iterator ();
		public abstract bool remove (G item);
		public virtual bool remove_all (Gee.Collection<G> collection);
		public virtual bool retain_all (Gee.Collection<G> collection);
		public virtual G[] to_array ();
		public virtual bool is_empty { get; }
		public abstract int size { get; }
	}
	[CCode (cheader_filename = "gee.h")]
	public abstract class AbstractList<G> : Gee.AbstractCollection<G>, Gee.List<G> {
		public virtual G first ();
		public abstract G @get (int index);
		public abstract int index_of (G item);
		public abstract void insert (int index, G item);
		public virtual void insert_all (int index, Gee.Collection<G> collection);
		public virtual G last ();
		public abstract void remove_at (int index);
		public abstract void @set (int index, G item);
		public abstract Gee.List<G>? slice (int start, int stop);
	}
	[CCode (cheader_filename = "gee.h")]
	public abstract class AbstractMap<K,V> : GLib.Object, Gee.Map<K,V> {
		public abstract void clear ();
		public abstract bool contains (K key);
		public virtual bool contains_all (Gee.Map<K,V> map);
		public abstract V @get (K key);
		public abstract Gee.Set<K> get_keys ();
		public abstract Gee.Collection<V> get_values ();
		public abstract bool remove (K key, out V value = null);
		public virtual bool remove_all (Gee.Map<K,V> map);
		public abstract void @set (K key, V value);
		public virtual void set_all (Gee.Map<K,V> map);
		public virtual bool is_empty { get; }
		public abstract int size { get; }
	}
	[CCode (cheader_filename = "gee.h")]
	public class ArrayList<G> : Gee.AbstractList<G> {
		public override bool add (G item);
		public override bool add_all (Gee.Collection<G> collection);
		public override void clear ();
		public override bool contains (G item);
		public override G @get (int index);
		public override int index_of (G item);
		public override void insert (int index, G item);
		public override Gee.Iterator<G> iterator ();
		public ArrayList (GLib.EqualFunc equal_func = GLib.direct_equal);
		public override bool remove (G item);
		public override bool remove_all (Gee.Collection<G> collection);
		public override void remove_at (int index);
		public override bool retain_all (Gee.Collection<G> collection);
		public override void @set (int index, G item);
		public override Gee.List<G>? slice (int start, int stop);
		public GLib.EqualFunc equal_func { get; construct; }
		public override int size { get; }
	}
	[CCode (cheader_filename = "gee.h")]
	public class HashMap<K,V> : Gee.AbstractMap<K,V> {
		public override void clear ();
		public override bool contains (K key);
		public override V @get (K key);
		public override Gee.Set<K> get_keys ();
		public override Gee.Collection<V> get_values ();
		public HashMap (GLib.HashFunc key_hash_func = GLib.direct_hash, GLib.EqualFunc key_equal_func = GLib.direct_equal, GLib.EqualFunc value_equal_func = GLib.direct_equal);
		public override bool remove (K key, out V value = null);
		public override void @set (K key, V value);
		public GLib.EqualFunc key_equal_func { get; construct; }
		public GLib.HashFunc key_hash_func { get; construct; }
		public override int size { get; }
		public GLib.EqualFunc value_equal_func { get; construct; }
	}
	[CCode (cheader_filename = "gee.h")]
	public class HashSet<G> : Gee.AbstractCollection<G>, Gee.Set<G> {
		public override bool add (G key);
		public override void clear ();
		public override bool contains (G key);
		public override Gee.Iterator<G> iterator ();
		public HashSet (GLib.HashFunc hash_func = GLib.direct_hash, GLib.EqualFunc equal_func = GLib.direct_equal);
		public override bool remove (G key);
		public GLib.EqualFunc equal_func { get; construct; }
		public GLib.HashFunc hash_func { get; construct; }
		public override int size { get; }
	}
	[CCode (cheader_filename = "gee.h")]
	public class LinkedList<G> : Gee.AbstractList<G> {
		public override bool add (G item);
		public override void clear ();
		public override bool contains (G item);
		public override G @get (int index);
		public override int index_of (G item);
		public override void insert (int index, G item);
		public override Gee.Iterator<G> iterator ();
		public LinkedList (GLib.EqualFunc equal_func = GLib.direct_equal);
		public override bool remove (G item);
		public override void remove_at (int index);
		public override void @set (int index, G item);
		public override Gee.List<G>? slice (int start, int stop);
		public GLib.EqualFunc equal_func { get; construct; }
		public override int size { get; }
	}
	[CCode (cheader_filename = "gee.h")]
	public class ReadOnlyCollection<G> : GLib.Object, Gee.Iterable<G>, Gee.Collection<G> {
		public ReadOnlyCollection (Gee.Collection<G>? collection = null);
		public Gee.Collection<G> collection { construct; }
	}
	[CCode (cheader_filename = "gee.h")]
	public class ReadOnlyList<G> : GLib.Object, Gee.Iterable<G>, Gee.Collection<G>, Gee.List<G> {
		public ReadOnlyList (Gee.List<G>? list = null);
		public Gee.List<G> list { construct; }
	}
	[CCode (cheader_filename = "gee.h")]
	public class ReadOnlyMap<K,V> : GLib.Object, Gee.Map<K,V> {
		public ReadOnlyMap (Gee.Map<K,V>? map = null);
		public Gee.Map<K,V> map { construct; }
	}
	[CCode (cheader_filename = "gee.h")]
	public class ReadOnlySet<G> : GLib.Object, Gee.Iterable<G>, Gee.Collection<G>, Gee.Set<G> {
		public ReadOnlySet (Gee.Set<G>? @set = null);
		public Gee.Set<G> @set { construct; }
	}
	[CCode (cheader_filename = "gee.h")]
	public class TreeMap<K,V> : Gee.AbstractMap<K,V> {
		public override void clear ();
		public override bool contains (K key);
		public override V @get (K key);
		public override Gee.Set<K> get_keys ();
		public override Gee.Collection<V> get_values ();
		public TreeMap (GLib.CompareFunc key_compare_func = Gee.direct_compare, GLib.EqualFunc value_equal_func = GLib.direct_equal);
		public override bool remove (K key, out V value = null);
		public override void @set (K key, V value);
		public GLib.CompareFunc key_compare_func { get; construct; }
		public override int size { get; }
		public GLib.EqualFunc value_equal_func { get; construct; }
	}
	[CCode (cheader_filename = "gee.h")]
	public class TreeSet<G> : Gee.AbstractCollection<G>, Gee.Set<G> {
		public override bool add (G item);
		public override void clear ();
		public override bool contains (G item);
		public override Gee.Iterator<G> iterator ();
		public TreeSet (GLib.CompareFunc compare_func = Gee.direct_compare);
		public override bool remove (G item);
		public GLib.CompareFunc compare_func { get; construct; }
		public override int size { get; }
	}
	[CCode (cheader_filename = "gee.h")]
	public interface Collection<G> : Gee.Iterable<G> {
		public abstract bool add (G item);
		public abstract bool add_all (Gee.Collection<G> collection);
		public abstract void clear ();
		public abstract bool contains (G item);
		public abstract bool contains_all (Gee.Collection<G> collection);
		public abstract bool remove (G item);
		public abstract bool remove_all (Gee.Collection<G> collection);
		public abstract bool retain_all (Gee.Collection<G> collection);
		public abstract G[] to_array ();
		public abstract bool is_empty { get; }
		public abstract int size { get; }
	}
	[CCode (cheader_filename = "gee.h")]
	public interface Iterable<G> : GLib.Object {
		public abstract Gee.Iterator<G> iterator ();
		public abstract GLib.Type element_type { get; }
	}
	[CCode (cheader_filename = "gee.h")]
	public interface Iterator<G> : GLib.Object {
		public abstract G @get ();
		public abstract bool next ();
	}
	[CCode (cheader_filename = "gee.h")]
	public interface List<G> : Gee.Collection<G> {
		public abstract G first ();
		public abstract G @get (int index);
		public abstract int index_of (G item);
		public abstract void insert (int index, G item);
		public abstract void insert_all (int index, Gee.Collection<G> collection);
		public abstract G last ();
		public abstract void remove_at (int index);
		public abstract void @set (int index, G item);
		public abstract Gee.List<G>? slice (int start, int stop);
	}
	[CCode (cheader_filename = "gee.h")]
	public interface Map<K,V> : GLib.Object {
		public abstract void clear ();
		public abstract bool contains (K key);
		public abstract bool contains_all (Gee.Map<K,V> map);
		public abstract V @get (K key);
		public abstract Gee.Set<K> get_keys ();
		public abstract Gee.Collection<V> get_values ();
		public abstract bool remove (K key, out V value = null);
		public abstract bool remove_all (Gee.Map<K,V> map);
		public abstract void @set (K key, V value);
		public abstract void set_all (Gee.Map<K,V> map);
		public abstract bool is_empty { get; }
		public abstract int size { get; }
	}
	[CCode (cheader_filename = "gee.h")]
	public interface Set<G> : Gee.Collection<G> {
	}
	[CCode (cheader_filename = "gee.h")]
	public static int direct_compare (void* _val1, void* _val2);
}
